/*
  File:      NearDetDAQChannelMapConstants.h
  Author:    Hayes Merritt
  Created:   April 30th, 2014
*/

#ifndef NEARDETDAQCHANNELMAPCONSTANTS_H
#define NEADETDAQCHANNELMAPCONSTANTS_H
#include <stdint.h>

namespace daqchannelmap{

// Listing Far Detector hardware constants.
  uint32_t ND_NUM_CELLS_DCM = 64;
  uint32_t ND_NUM_PLANES_DIBLOCK = 64;
  uint32_t ND_NUM_PLANES_BLOCK = 24;
  uint32_t ND_NUM_CELLS_PLANE = 96;
  uint32_t ND_NUM_CELLS_YPLANE_MC = 96;
  uint32_t ND_NUM_CELLS_XPLANE_MC = 64;
  uint32_t ND_NUM_DIBLOCKS = 4;
  uint32_t ND_NUM_DCMS = 4;
  uint32_t ND_MC_NUM_DCMS = 2;
  
  // Mapping index is the pixel, result is fiber
  const unsigned int pixel2fiber[] = {25,24,27,26,29,28,31,30,
				      17,16,19,18,21,20,22,23,
				      15,14,12,13,10,11, 8, 9,
				      6, 7, 4, 5, 2, 3, 0, 1};
  
  // Mapping index is the fiber, result is the pixel
  const unsigned int fiber2pixel[] = {30,31,28,29,26,27,24,25,
				      22,23,20,21,18,19,17,16,
				      9, 8,11,10,13,12,14,15,
				      1, 0, 3, 2, 5, 4, 7, 6};
  
}
#endif


