#ifndef RAWDATABLOCKV1_H
#define RAWDATABLOCKV1_H
#include "DAQDataFormats/RawDataBlockHeader.h"
#include "DAQDataFormats/RawDataBlockV0.h"
#include "DAQDataFormats/RawSummaryDroppedMicroblock.h"

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawDataBlock
#define  CURRENT_CLASS_VERSION        1
#define  CURRENT_FIELDS_SUB_NAMESPACE datablock
#include "DAQDataFormats/DataFormatLast.inc"

namespace daqdataformats {
namespace  VERSION_NAMESPACE {

    class RawDataBlock : public PREVIOUS_VERSION_CLASS_NAME {
        protected:
            /// Constructors
    RawDataBlock(const version_t, const uint32_t tlvl);
            RawDataBlock(const RawDataBlock&);
            /// Destructor
            ~RawDataBlock();
        public:

            /// Add the Dropped MicroBlock Summary to _Buffer.
	    /// The setMarker function will be called to indicate that this is a Summary Block
	    bool addDroppedMicroblock( const void* droppedmicroblock_buffer );
	    daqdataformats::RawSummaryDroppedMicroblock* getDroppedMicroblock();

	    // addDCMData1 and addDCMData2 are only defined in Version 2
	    bool addDCMData1(const void*) { return GENERATE_FUNCTION_IS_NOT_ALLOWED; }
	    bool addDCMData2(const void*, const uint32_t) { return GENERATE_FUNCTION_IS_NOT_ALLOWED; }
        protected:
	    INIT_FIRST(setMarker, , bool, const uint32_t );
            INIT_CUSTOM_DELEGATE(addDroppedMicroblock, bool, const void*);
    };// end of class definition
  
}} // END NAMESPCE daqdataformats
#endif /* RAWDATABLOCKV0_H */
