#ifndef RAWDATABLOCKV2_H
#define RAWDATABLOCKV2_H
#include "DAQDataFormats/RawDataBlockHeader.h"
#include "DAQDataFormats/RawDataBlockV1.h"
#include "DAQDataFormats/RawSummaryDCMData.h"

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawDataBlock
#define  CURRENT_CLASS_VERSION        2
#define  CURRENT_FIELDS_SUB_NAMESPACE datablock
#include "DAQDataFormats/DataFormatLast.inc"

namespace daqdataformats {
namespace  VERSION_NAMESPACE {

    class RawDataBlock : public PREVIOUS_VERSION_CLASS_NAME {
        protected:
            /// Constructors
    RawDataBlock(const version_t, const uint32_t tlvl);
            RawDataBlock(const RawDataBlock&);
            /// Destructor
            ~RawDataBlock();
        public:

	    bool addDCMData1( const void* dcmdata_buffer );
	    bool addDCMData2( const void* dcmdata_buffer, const uint32_t dcmdata_size );

	    RawSummaryDCMData* getDCMData();

        protected:
            INIT_CUSTOM_DELEGATE(addDCMData1, bool, const void*);
            INIT_CUSTOM_DELEGATE(addDCMData2, bool, const void*, const uint32_t);
    };// end of class definition
  
}} // END NAMESPCE daqdataformats
#endif /* RAWDATABLOCKV0_H */
