#ifndef RAWMICROSLICEHEADER_H
#define RAWMICROSLICEHEADER_H
#include "DAQDataFormats/RawMicroSliceHeaderV1.h"

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawMicroSliceHeader
#define  LAST_CLASS_VERSION           1
#define  CURRENT_FIELDS_SUB_NAMESPACE rawmuhdr
#include "DAQDataFormats/DataFormatLast.inc"

namespace daqdataformats{
    class RawMicroSlice;
}


namespace daqdataformats {

    namespace CURRENT_FIELDS_SUB_NAMESPACE {
        static const version_t RAWMICROSLICE_LATEST_VERSION  = LAST_CLASS_VERSION;
        static const version_t RAWMICROSLICE_DEFAULT_VERSION = 0;
    }
  
  class RawMicroSliceHeader: public PREVIOUS_VERSION_CLASS_NAME {
    
        public:
            /// Constructors
            RawMicroSliceHeader(const version_t version = CURRENT_FIELDS_SUB_NAMESPACE::RAWMICROSLICE_DEFAULT_VERSION);                              ///! The default constructor
            RawMicroSliceHeader(const RawMicroSliceHeader&);    ///! Deep copy constructor
            RawMicroSliceHeader(const void*     microsliceheader_buffer
                               ,const version_t version = rawdaqdataformat::DAQDATAFORMAT_UNKNOWN_VERSION); ///! Shallow copy constructor
            /// Destructor
            ~RawMicroSliceHeader();

            IMPLEMENT_GET_AND_SET_MAIN(Extra , uint32_t);
            IMPLEMENT_GET_AND_SET_MAIN(Status, uint32_t);

            bool setVersion(const version_t);

            IMPLEMENT_FIGUREOUT_VERSION_STATIC(RawMicroSliceHeader)

        protected:
            bool setFunctionPointers();
            /// Don't change the field
            bool setVersionSoft(const version_t);

            friend class RawMicroSlice;
  };
  
  
} // END NAMESPCE daqdataformats
#endif /* RAWMICROSLICEHEADER_H */
