#ifndef DISPATCHERACK_H
#define DISPATCHERACK_H

#include <sys/types.h>
#include <stdint.h>
#include <memory>
#include "EventDispatcher_CommandSet/DispatcherCmd.h"

// namespace EventDispatcher {

  class DispatcherACK {

 public:
   
   enum DispatcherResponses{
     DSPRES_ACK                        = 6
   };
   
   DispatcherACK(unsigned char* output_buff);

   bool notEmpty();
   ssize_t write();
   template< typename T> void acknowledgeCommand(DispatcherCMD::DispatcherCommands cmd, T& value);
   
   private:
     unsigned char* external_buff;
     std::auto_ptr<DispatcherCMD> acknowledged_commands;
};

template < typename T> 
void DispatcherACK::acknowledgeCommand(DispatcherCMD::DispatcherCommands cmd, T& value) {
  acknowledged_commands->addCommand(cmd,value);
  ++(*(external_buff+1));
}

//} // endnamespace

#endif /* DISPATCHERACK_H */
