#include "DAQDataFormats/RawDCMChan.h"
#include <boost/format.hpp>

namespace daqdataformats{
//------------------------------------------------------------------------------
// Default constructor
RawDCMChan::RawDCMChan():
    RawDAQData(0,(const sizeofdata_t) &RawDCMChan::sizeofdata)
{
    /// Perform general routines
    defaultConstructorFixedSize();
}
//------------------------------------------------------------------------------
RawDCMChan::RawDCMChan(const RawDCMChan& copy_in):
    RawDAQData(copy_in)
{
    lastOperationsInDeepCopy(copy_in);
}


//------------------------------------------------------------------------------
RawDCMChan::RawDCMChan(const void* dcmchan_buffer):
    RawDAQData(0,(const sizeofdata_t) &RawDCMChan::sizeofdata)
{
   copy(dcmchan_buffer);
}

//------------------------------------------------------------------------------
// Destructor
RawDCMChan::~RawDCMChan() { }

//------------------------------------------------------------------------------
// Print the MilliSlice DCM Channel identification information
void RawDCMChan::print(std::ostream& os) const{
    os<<boost::format(" DiblockId=%u DCMId=%u DetId=%u  RAW=")% getDiblockId()
                                                              % getDCMId()
                                                              % getDetId();
    
    printWord(0,false, os);
    os<<std::endl;
    printWord(0,true, os);
}


} // end of namespace