#include "DAQDataFormats/RawSummaryDCMDataPoint.h"
#include "DAQDataFormats/DataFormatException.h"

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawSummaryDCMDataPoint
#define  LAST_CLASS_VERSION           0
#define  CURRENT_FIELDS_SUB_NAMESPACE summarydcmdatapoint
#include "DAQDataFormats/DataFormatLast.inc"

namespace daqdataformats{
 
//------------------------Constructors------------------------------------------
/// After this constructor the buffer pointer is set to the internal source
RawSummaryDCMDataPoint::RawSummaryDCMDataPoint(const version_t version):
             PREVIOUS_VERSION_CLASS_NAME(version)
{
    INITIALIZE_DEBUGGING_VARIABLES;
    /// Perform general routines
    defaultConstructorFixedSize();
}// end of :RawSummaryDCMDataPoint(version_t version)

//------------------------------------------------------------------------------
/// After this constructor the buffer pointer is set to the external source
RawSummaryDCMDataPoint::RawSummaryDCMDataPoint(const RawSummaryDCMDataPoint& copy_in): 
             PREVIOUS_VERSION_CLASS_NAME(copy_in)
{
    INITIALIZE_DEBUGGING_VARIABLES;
    lastOperationsInDeepCopy(copy_in);

}// end of RawSummaryDCMDataPoint(const RawSummaryDCMDataPoint& copy_in)

//------------------------------------------------------------------------------
// check how to get the version number
RawSummaryDCMDataPoint::RawSummaryDCMDataPoint(const void* datapoint_buffer, const version_t version): 
             PREVIOUS_VERSION_CLASS_NAME(version)
{
    INITIALIZE_DEBUGGING_VARIABLES;
    copy(datapoint_buffer);
}

//------------------------Destructor--------------------------------------------
RawSummaryDCMDataPoint::~RawSummaryDCMDataPoint() { }

/// All binding routines
#define STANDARD_ROUTINES                                      \
            BIND_GET_AND_SET(Version                  , version0, uint32_t);\
            BIND_GET_AND_SET(DCMID , version0, uint32_t);\
	    BIND_GET_AND_SET(DataType, version0, uint32_t);\
            BIND_GET_AND_SET(TimeStampLow   , version0, uint32_t);\
            BIND_GET_AND_SET(TimeStampHigh   , version0, uint32_t);\
            BIND_GET_AND_SET(TimeStamp   , version0, uint64_t);\
            BIND_STADARD_FUNCTION(sizeofdata);                  \
            BIND_STADARD_FUNCTION(readData);
            

#include "DAQDataFormats/setFunctionPointers_template.inc"


}// end of namespace


